Subject: Ftp-WG: multi-line responses acceptable when?

From: Pat LaVarre <[email-masked]>
Date: Wed, 23 Jan 2002 08:55:53 -0500

> Subject: Ftp-WG: to mlst-14 from mlst-13 
> From: [email-masked]
> Date: Monday - January 14, 2002 2:01 AM
> I'm not sure what you're getting at there?

Am I wrong to infer Ftp folk commonly understand
rfc2389 [Ftp Feature Negotiation] and mlst-14 to say
....

Many kinds of replies must Never be multi-line
replies?

I'm guessing the replies that must Never be multi-line
are the replies commonly parsed: the 125/150 to STOU,
213 to MDTM/SIZE, 227 to PASV, 229 to EPSV, and 257 to
PWD/MKD.

I'm wondering again now because I see mlst-14 repeats,
almost verbatim from rfc2389 [Ftp Feature
Negotiation], explicitly contrary "unless otherwise
stated" English:

2.4. Server Replies
Section 4.2 of [3] defines the format and meaning of
replies by the server-PI to FTP commands from the
user-PI.  Those reply conventions are used here
without change.

        error-response = error-code SP *TCHAR CRLF
        error-code     = ("4" / "5") 2DIGIT

Implementors should note that the ABNF syntax (which
was not used in [3]) used in this document, and other
FTP related documents, sometimes shows replies using
the one line format.  Unless otherwise explicitly
stated, that is not intended to imply that multi-line
responses are not permitted.  Implementors should
assume that, unless stated to the contrary, any reply
to any FTP command (including QUIT) may be of the
multi-line format described in [3].

> almost verbatim

Vs. rfc2389, mlst-14 replaces "])" with "]) used" and
inserts the paragraph break and ABNF.

> I'm wondering again now

I'm prompted to post because just recently I received
a relevant paragraph offline:

PASV is another one where it makes no sense for there
to be a multi-line reply, had anyone ever really
considered the issue before, I'm sure it would have
been forbidden.   Multi-line replies only make sense
when the reply is essentially just meaningless text
(intended for humans rather than for the client
process)."

> I'm wondering again now

The final reason I wonder, I mentioned before here to
no online reply, namely:

I read rfc959 [Ftp] 5.4. Spontaneous Replies to say an
FtpServer may choose from among such replies as:

       C> MDTM A
       S> 213 19980615100045.014

and:

       C> MDTM A
       S> 213-Please QUIT within five minutes.
       S> 213 19980615100045.014

and:

       C> MDTM A
       S> 213-19980615100045.014
       S> 213 Please QUIT within five minutes.

if it weren't that mlst-14 explicitly says the 213
replies to MDTM/SIZE must be single line replies.

I see mlst-14 doesn't mention the 125/150 to STOU, 227
to PASV, 229 to EPSV, and 257 to PWD/MKD replies.

I see mlst-14 doesn't say the 250 reply to MLST can't
contain rfc959 Spontaneous Replies ... I'm also
imagining people commonly understand that restriction
to be implied.

Thanks in advance.    Pat LaVarre

__________________________________________________
Do You Yahoo!?
Send FREE video emails in Yahoo! Mail!
http://promo.yahoo.com/videomail/